﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerAttack : MonoBehaviour
{
    public Vector2 attackCenterOffset;
    public Vector3 AttcackSize;
    public LayerMask enemyLayer;
    public float damage;
    public Animator anim;
    public Transform attackZone;

    PlayerMouvement pm;

    bool isAtacking = false;

    // Start is called before the first frame update
    void Start()
    {
        pm = GetComponent<PlayerMouvement>();
    }

    // Update is called once per frame
    void Update()
    {

        if (Input.GetButtonDown("Attack") && !isAtacking)
        {
            anim.SetTrigger("Atack");
            isAtacking = true;
            pm.canMove = false;
        }
    }

    
    public void Attack()
    {
        var colls = Physics.OverlapBox(transform.position + transform.forward * attackCenterOffset.x + transform.up * attackCenterOffset.y, AttcackSize, transform.rotation, enemyLayer);

        foreach (var coll in colls)
        {
            //if (Vector3.Distance(transform.position, coll.transform.position) > 2f) return;

            coll.TryGetComponent(out HealthSystem healthSys);

            if (healthSys == null)
            {
                continue;
            }
            else
            {
                healthSys.Hurt((int)damage, "player");
            }

        }
    }

    public void EndAttack()
    {
        isAtacking = false;
        pm.canMove = true;
    }

    private void OnDrawGizmosSelected()
    {
        Gizmos.color = Color.green;
        Gizmos.DrawWireCube(transform.position + transform.forward * attackCenterOffset.x + transform.up * attackCenterOffset.y, AttcackSize);
    }
}
