﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Pool : MonoBehaviour
{
    public List<GameObject> pool;
    public GameObject prefab;

    private void Start()
    {
        AddToPool(20);
    }

    public GameObject GetFromPool()
    {
        if (pool.Count <= 0) AddToPool(1);

        var obj = pool[0];
        pool.Remove(obj);
        obj.transform.parent = null;
        obj.SetActive(true);
        return obj;

    }

    public void AddToPool(int nbtoadd)
    {
        for (int i = 0; i < nbtoadd; i++)
        {
            var obj = Instantiate(prefab, transform);
            obj.SetActive(false);
            obj.AddComponent<BackToPool>().originPool = this;
            pool.Add(obj);
        }
    }

    public void BackToPool(GameObject objBack)
    {
        pool.Add(objBack);
    }
}
